//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * ジェライム攻撃状態実装
 * @author Junpee
 */

#include "Core/Utility/stdafx.h"
#include "Enemy/Gelaim/GelaimAttackState.h"
#include "Game/Sound/SoundSystem.h"
#include "Enemy/System/Enemy.h"
#include "Stage/System/Stage.h"

#include "Enemy/Gelaim/GelaimStandState.h"
#include "Enemy/Gelaim/GelaimRunState.h"

//------------------------------------------------------------------------------
// 生成、破棄
//------------------------------------------------------------------------------
// コンストラクタ
GelaimAttackState::GelaimAttackState(Gelaim* gelaim) : GelaimState(gelaim){
}
//------------------------------------------------------------------------------
// デストラクタ
GelaimAttackState::~GelaimAttackState(){
}
//------------------------------------------------------------------------------
// 実行
//------------------------------------------------------------------------------
// 初期化
void GelaimAttackState::initialize(){
	// アニメーションシーケンス設定
	getAnimation()->setSequence(2);
	// 攻撃音を鳴らす
	getSoundSystem()->play("GelaimAttack");
}
//------------------------------------------------------------------------------
// 後始末
void GelaimAttackState::finalize(){
	// コリジョンを無効に戻す
	getAttackCollision()->setEnabled(false);
}
//------------------------------------------------------------------------------
// 実行
void GelaimAttackState::run(){
	// 定数
	float animationScale = 1.f;
	float moveXZScale = 0.01f;

	// ステート変更
	if(!isDamaged()){
		if(getRunCounter() == 60){
			getEnemy()->setState(new GelaimStandState(getGelaim()));
		}
	}

	// 位置と速度の計算
	calcVelocityAndPosition();
	// 向きの設定
	setDirection(getPlayerDirection());

	// 地形コリジョン
	landCollide();

	// 描画セットアップ
	drawSetup(animationScale);

	// 攻撃
	if(getRunCounter() == 20){ getAttackCollision()->setEnabled(true); }
	if(getRunCounter() == 30){ getAttackCollision()->setEnabled(false); }
	if(getAttackCollision()->isEnabled()){
		attackCollide(getAttackBone(), Vector3(5.f, 0.f, 5.f), 5.f, 30);
	}

}
//------------------------------------------------------------------------------
